//vc/ VC/m JavaScript File Class
//vc/ Copyright 2003 George James
//vc/ Object:    JavaScript.js
//vc/ Component: T.JavaScript.js


	// JavaScript Class
JavaScript = {}

JavaScript.Current=Disabled;
JavaScript.windowProperties  = 'left=50,top=50,width=500,height=250,toolbar=no';
JavaScript.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';


	// Public - Display List of JS files and make this the active folder
JavaScript.fnList = function() {
	//
	SelectedClass=JavaScript;
	Class.fnUnselect();
	//
	ServerLink.fnDo('JavaScript.fnListResult','JavaScript.fnList','')
}

JavaScript.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}


	// Private - Invoked when an item is selected on the list
JavaScript.fnSelect = function(oCell) {
	Class.fnSelect(JavaScript,oCell);
}


	// Public - Open new JS file window
JavaScript.fnNew = function() {
	fnRunWindow("JavaScript.fnNew",JavaScript.windowProperties); 
}

	// Public - Open JS file
JavaScript.fnOpen = function(sJsFile) {
	//
	var url;
	//
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('JavaScript.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sJsFile) ;
	//
	// Open change request window
	winChref=window.open(url,'_blank',JavaScript.windowProperties) ;
	winChref.focus();
}

	// Public - Arguments for Refresh Function
JavaScript.fnRefreshArguments = function(oMain)   {
	//
	var arguments=""
	//
	arguments +=          getAttr(oMain,"gjsItem")
	arguments += '\002' + getAttr(oMain,"gjsRowId")
	//
	return arguments
}


	// Public - Refresh Function
JavaScript.fnRefresh = function(arguments)   {
	//
	ServerLink.fnDo('JavaScript.fnRefreshResult','JavaScript.fnRefresh',arguments)
}


JavaScript.fnRefreshResult = function(oResult) {
	gjsTree.fnRefreshRows("divMainBody",oResult)
	gjsTree.fnDeleteRows("divRowDelete",oResult)
}


	// Public - Delete a JS file
JavaScript.fnDelete = function(sJsFile) {
	//
	var arguments;
	//
	if (!confirm("Are you sure you want to delete "+sJsFile+" ?")) return;
	//
	arguments = sJsFile;
	//
	parent.serverLink.fnDo('JavaScript.fnDeleteResult','JavaScript.fnDelete',arguments);
}


JavaScript.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	JavaScript.fnList();
}

JavaScript.Item = {}

JavaScript.Item.fnDelete = function() {
	if (typeof(JavaScript.Current)=='undefined') return;
	JavaScript.fnDelete(getAttr(JavaScript.selectedCell,"gjsItem"));
}
	// Public - open selected JS file (if there is one)
JavaScript.Item.fnOpen = function() {
	if (typeof(JavaScript.Current)=='undefined') return;
	JavaScript.fnOpen(getAttr(JavaScript.selectedCell,"gjsItem"));
}

