//vc/ Deltanji Object Class
//vc/ Copyright 1999,2005 George James
//vc/ Object:    Object.js
//vc/ Component: T.Object.js


	// Object Class
  
  // Unlike all our other classes, this one's name clashes with the built-in Object object.
  // We get away with adding properties and methods to it, but we must not redefine it entirely,
  // so the following line is commented out:
  //Object = {}



	// Initialise to no current selection
Object.Current=Disabled;
  //
  // The Object Properties dialog
Object.windowObjectProperties  = 'left=100,top=100,width=575,height=500,toolbar=no';
Object.windowObjectProperties += ',location=no,directories=no,status=no,resizable=yes,menubar=no';
  //
  // The transfer dialog (by-object, by-CR or by-component) 
Object.windowProperties  = 'left=100,top=100,width=680,height=260,toolbar=no';
Object.windowProperties += ',location=no,directories=no,status=no,resizable=yes,menubar=no';
  //
  // The bulk transfer dialog 
Object.windowBulkTransferProperties  = 'left=100,top=100,width=600,height=400,toolbar=no';
Object.windowBulkTransferProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';


	// Public - Display List of objects within a location and make this the active folder
Object.fnList = function() {
	//
	var arguments
	//
	SelectedClass=Object
	Class.fnUnselect()
	//
	fnMessageSelecting()
	//
	// Get Object Version list
	arguments = getAttr(g_oSelectedFolder,'gjsItem') // Location code
	arguments += delimiter + '' // No system code
	if ($('#lstSelect').scombobox('val')=='') {
		arguments += delimiter + Select.fnFilters()
		parent.serverLink.fnDo('Object.fnPrepareSelectorResult','Object.fnPrepareSelector',arguments)
	} else {
		arguments += delimiter + $('#lstSelect').scombobox('val')
		arguments += delimiter + Select.fnFilters()
		parent.serverLink.fnDo('Object.fnListResult','Object.fnList',arguments)
	}
}


Object.fnPrepareSelectorResult = function(oResult) {
	//
	// Update Select toolbars
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
	//
	// Check for error messages
	if (oResult.getElementById('divInfo')) {
		document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
	}
	//
	// Now get the Object Version list
	if ($('#lstSelect').scombobox('val')!='') {
		arguments = getAttr(g_oSelectedFolder,'gjsItem'); // Location code
		arguments += delimiter + '' // No system code
		arguments += delimiter + $('#lstSelect').scombobox('val');
		arguments += delimiter + Select.fnFilters();
		// Queue the subsequent server-side call rather than invoking it directly, otherwise it happens before an already-queued reset of the wait-cursor
		setTimeout('parent.serverLink.fnDo("Object.fnListResult","Object.fnList",' + arguments.quote() + ')',0);
	}
}


Object.fnListResult = function(oResult) {
  //
  // Check for error messages
  if (oResult.getElementById('divInfo')) {
    document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
  }
  //
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}


	// Public - Display List of objects within a system and make this the active folder
Object.fnListSystem = function() {
	//
	var arguments
	//
	SelectedClass=Object
	Class.fnUnselect()
	//
	fnMessageSelecting()
	//
	// Get Object Version list
	arguments = '' // No location code
	arguments += delimiter + getAttr(g_oSelectedFolder,'gjsItem') // System code
	if ($('#lstSelect').scombobox('val')=='') {
		arguments += delimiter + Select.fnFilters()
		parent.serverLink.fnDo('Object.fnPrepareSelectorSystemResult','Object.fnPrepareSelector',arguments)
	} else {
		arguments += delimiter + $('#lstSelect').scombobox('val')
		arguments += delimiter + Select.fnFilters()
		parent.serverLink.fnDo('Object.fnListResult','Object.fnList',arguments)
	}
}


Object.fnPrepareSelectorSystemResult = function(oResult) {
	//
	// Update Select toolbars
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
	//
	// Check for error messages
	if (oResult.getElementById('divInfo')) {
		document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
	}
	//
	// Now get the Object Version list
	if ($('#lstSelect').scombobox('val')!='') {
		arguments = ''; // No location code
		arguments += delimiter + getAttr(g_oSelectedFolder,'gjsItem') // System code
		arguments += delimiter + $('#lstSelect').scombobox('val');
		arguments += delimiter + Select.fnFilters();
		// Queue the subsequent server-side call rather than invoking it directly, otherwise it happens before an already-queued reset of the wait-cursor
		setTimeout('parent.serverLink.fnDo("Object.fnListResult","Object.fnList",' + arguments.quote() + ')',0);
	}
}


	// Public - Display List of objects and make this the active folder
Object.fnListAll = function(oFolder) {
	//
	var arguments
	//
	// Guarantee transfer menu from top-level Objects folder passes empty from-location
	if (typeof getAttr(oFolder,'gjsItem') == 'undefined') setAttr(oFolder,'gjsItem','');
	//
	SelectedClass=Object
	Class.fnUnselect()
	//
	fnMessageSelecting()
	//
	// Get Object Version list
	arguments = '' // No Location code
	arguments += delimiter + '' // No system code
	if ($('#lstSelect').scombobox('val')=='') {
		arguments += delimiter + Select.fnFilters()
		parent.serverLink.fnDo('Object.fnPrepareSelectorAllResult','Object.fnPrepareSelector',arguments)
	} else {
		arguments += delimiter + $('#lstSelect').scombobox('val')
		arguments += delimiter + Select.fnFilters()
		parent.serverLink.fnDo('Object.fnListResult','Object.fnList',arguments)
	}
}


Object.fnPrepareSelectorAllResult = function(oResult) {
	//
	var arguments
	//
	// Update Select toolbars
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
	//
	// Check for error messages
	if (oResult.getElementById('divInfo')) {
		document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
	}
	//
	// Now get the Object Version list
	if ($('#lstSelect').scombobox('val')!='') {
		arguments = ''; // No location code
		arguments += delimiter + '' // No system code
		arguments += delimiter + $('#lstSelect').scombobox('val');
		arguments += delimiter + Select.fnFilters();
		// Queue the subsequent server-side call rather than invoking it directly, otherwise it happens before an already-queued reset of the wait-cursor
		setTimeout('parent.serverLink.fnDo("Object.fnListResult","Object.fnList",' + arguments.quote() + ')',0);
	}
}


	// Public - New Object
Object.fnNew = function() {
	Component.fnTransfer('','REGISTER',((getAttr(g_oSelectedFolder,'gjsItemType')!='SYSTEM')? getAttr(g_oSelectedFolder,'gjsItem') : ''),'','','');
}


       // Public - Delete Object
Object.fnDelete = function(sObject) {
	var arguments
	if (!confirm("WARNING: This operation will delete all information about this Object Version, including its master copy, its audit trails and all of its components stored in any Deltanji library. It will not, however, physically delete components from any non-library location.")) return;
	//
	arguments = sObject
	//
	parent.serverLink.fnDo('Object.fnDeleteResult','Object.fnDelete',arguments)
}

Object.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result)
		return
	}
	fnRefreshSelected()
}


       // Public - Open Object
Object.fnOpen = function(sObject) {
	var url;
	//
	// Build url string
	url  = parent.serverUrl 
	url += '&page=' + encodeURIComponent('Object.fnOpen') ;
	url += '&user=' + encodeURIComponent(user) ;
	url += '&obv=' + encodeURIComponent(sObject) ;
	//
	// Open object window
	winObj=window.open(url,'_blank',Object.windowObjectProperties) ;
	winObj.focus();
}


	// Public - Transfer Object
Object.fnTransfer = function(sObject,sFunction,sLcode1,sLcode2) {
	var url;
	//
	// Build url string
	url = parent.serverUrl
	url += '&page=' + encodeURIComponent('Object.fnTransfer');
	url += '&function=' + encodeURIComponent(sFunction);
	url += '&obv=' + encodeURIComponent(sObject);
	url += '&lcode1=' + encodeURIComponent(sLcode1);
	url += '&lcode2=' + encodeURIComponent(sLcode2);
	url += '&user=' + encodeURIComponent(user);
	url += '&obvType=OBJECT';
	//
	// Open transfer window
	winTransfer=window.open(url,'Transfer',Object.windowProperties) ;
	winTransfer.focus();
}


	// Public - Transfer Object Selection
Object.fnTransferMultiple = function(sFunction,sLcode1,sLcode2) {
	fnInvokeOnSelection('Object.fnTransferMultipleDo','"'+sFunction+'","'+sLcode1+'","'+sLcode2+'"');
}


	// Private - Transfer Object Selection
Object.fnTransferMultipleDo = function(iSelKey,sFunction,sLcode1,sLcode2) {
	var url;
	//
	// Build url string
	url = parent.serverUrl
	url += '&page=' + encodeURIComponent('Object.fnTransfer');
	url += '&function=' + encodeURIComponent(sFunction);
	url += '&lcode1=' + encodeURIComponent(sLcode1);
	url += '&lcode2=' + encodeURIComponent(sLcode2);
	url += '&user=' + encodeURIComponent(user);
	url += '&obvType=SEL';
	url += '&obv=' + encodeURIComponent(iSelKey);
	//
	// Open transfer window
	winTransfer=window.open(url,'Transfer',Object.windowProperties) ;
	winTransfer.focus();
}


Object.fnMergeOpen = function(sLcode,sObject) {
	// Build url string
	url = parent.serverUrl
	url += '&page=' + encodeURIComponent('Object.fnMergeOpen')
	url += '&lcode=' + encodeURIComponent(sLcode)
	url += '&obv=' + encodeURIComponent(sObject)
	url += '&user=' + encodeURIComponent(user)
	//
	// Open merge window
	winMerge=window.open(url,'Merge',"top=50,left=50,width=700,height=600")
	winMerge.focus()
}


	// Cancel
Object.fnCancel = function(sObject) {
	//
	// Remember object for second call
	Object.fnCancel.sObject=sObject
	//
	// First check whether this version is valid to cancel
	parent.serverLink.fnDo('Object.fnCancelValidateResult','Object.fnCancelValidate',sObject)
}

Object.fnCancelValidateResult = function(oResult) {
	//
	if (!AuditTrail.fnRenderErrors(oResult)) return
	//
	parent.serverLink.fnDo('Object.fnCancelResult','Object.fnCancel',Object.fnCancel.sObject)
}

Object.fnCancelResult = function(oResult) {
	//
  AuditTrail.fnAppendMessages(oResult)
  fnRefreshSelected()  
}


	// Public - Remove an object from a change request
Object.fnRemove = function(sObject,sChangeRequest,sPtext,sRowId) {
	//
	var yn,arguments
	//
	// any object, any location, any state can be removed from any change request !
	yn=confirm("Are you sure you want to remove " + sObject + " from "+sPtext+" "+sChangeRequest+" ?")
	if (yn) {
		arguments = sObject 
		arguments += delimiter + sChangeRequest
		arguments += delimiter + sRowId
		parent.serverLink.fnDo('Object.fnRemoveResult','Object.fnRemoveFromChangeRequest',arguments);
	}
}

Object.fnRemoveResult = function(oResult) {
	AuditTrail.fnAppendMessages(oResult)  
	gjsTree.fnDeleteRows("divRowDelete",oResult)
}


	// Public - Remove multiple objects from a change request
Object.fnRemoveMultiple = function(sChangeRequest,sPtext,sParentId) {
	var yn
	//
	// any object, any location, any state can be removed from any change request !
	yn=confirm("Are you sure you want to remove " + Class.fnSelectionCount() + " objects from "+sPtext+" "+sChangeRequest+" ?")
	if (yn) {
		fnInvokeOnSelection('Object.fnRemoveMultipleDo','"'+sChangeRequest+'","'+sParentId+'"');
	}
}


	// Private - Perform multiple object removal from a change request
Object.fnRemoveMultipleDo = function(iSelKey,sChangeRequest,sParentId) {
	var arguments,oEl,oEl2
	arguments = iSelKey 
	arguments += delimiter + sChangeRequest
	//
	// Select the CR element so fnRefreshSelected refreshes only this when server side work has been done
	oEl=document.getElementById(sParentId)
	// If items being removed are part of a hybrid CR containing CRs and objects then we have to go one level up
	if (getAttr(oEl,'gjsParentId')!='') {
		oEl2=document.getElementById(getAttr(oEl,'gjsParentId'))
		if ((getAttr(oEl2,'gjsItemType')==getAttr(oEl,'gjsItemType'))&&(getAttr(oEl2,'gjsItem')==getAttr(oEl2,'gjsItem'))) oEl=oEl2
	}
	// Do it this way to ensure post-remove adds go to correct CR
	Class.fnClear()
	Class.fnSelect2(ChangeRequest,oEl)
	
	parent.serverLink.fnDo('Object.fnRemoveMultipleResult','Object.fnRemoveMultipleFromChangeRequest',arguments);
}

Object.fnRemoveMultipleResult = function(oResult) {
	AuditTrail.fnAppendMessages(oResult)
	fnRefreshSelected()  
}


	// Public - Compare Object with its predecessor using Beyond Compare
Object.fnBCompare = function(sObject1,sLcode1,sObject2,sLcode2) {
	//
	var arguments
	//
	arguments = sObject1
	arguments += delimiter + sLcode1
	if (typeof(sObject2)!='undefined') {
		arguments += delimiter + sObject2
		if (typeof(sLcode2)!='undefined') {
			arguments += delimiter + sLcode2
		}
	}

	 // Build url string
	var url = parent.serverUrl;
	url += '&page=' + encodeURIComponent('Object.fnBCompare.raw');
	url += '&arguments=' + encodeURIComponent(arguments);

	// Build properties string
	var windowProperties  = 'left=50,top=30,width=50,height=50,toolbar=no';
	windowProperties += ',location=no,directories=no,status=no,resizable=no,menubar=no';

	// Open report window (always in a new window)
	winPage = window.open(url, 'ObjectfnBCompare', windowProperties);
}


	// Derive refresh arguments for a selected item
Object.fnRefreshArguments = function(oMain) {
	//
	var arguments=""
	//
	// Don't try to build refresh arguments if selected item is in audit record
	if (typeof(getAttr(oMain,'gjsRowId'))!='undefined') {
		arguments +=          getAttr(oMain,'gjsParentId') // parentId
		arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,'gjsRowId')+'click').previousElementSibling) // mores
		arguments += '\002' + getAttr(oMain,'gjsLocation') // location
		arguments += '\002' + getAttr(oMain,'gjsItem') // objectVersion
		arguments += '\002' + getAttr(oMain,'gjsRowId') // rowId
		arguments += '\002' + getAttr(fnElement(getAttr(oMain,'gjsRowId')+'body').parentNode,'gjsReferenceHeadingId') // headingId
	}
	//
	return arguments
}


  // Public - Refresh an object
Object.fnRefresh = function(arguments) {
  // Do nothing if arguments are empty (e.g. selected item was in an audit record)
  if (arguments.match(/\x03*/g).length==1) return;
  //
  ServerLink.fnDo('Object.fnRefreshResult','Object.fnRefresh',arguments) 
}

Object.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}

	// Public - Open dialog to perform a bulk transfer
Object.fnBulkTransfer = function(sLocationFrom,sLocationTo) {
	var url
	//
	// Default the optional parameters
	if (typeof(sLocationFrom)=='undefined') sLocationFrom='';
	if (typeof(sLocationTo)=='undefined') sLocationTo='';
	//
	// Build url string
	url  = parent.serverUrl
	url += '&page=' + escape('Object.BulkTransfer.fnOpen')
	url += '&lcode1=' + encodeURIComponent(sLocationFrom)
	url += '&lcode2=' + encodeURIComponent(sLocationTo)
	//
	// Open label window
	winBulkTransfer=window.open(url,'_blank',Object.windowBulkTransferProperties)
	winBulkTransfer.focus()
}

	
	// Handle for selected item methods
Object.Item = {


 fnDelete: function() {
	if (typeof(Object.Current)=='undefined') return;
	Object.fnDelete(getAttr(Object.selectedCell,'gjsItem'));
 },

 fnOnKeyDel: function() {
	if (typeof(Object.Current)=='undefined') return;
	
	// If user selects an object under a change request the object gets removed from that CH otherwise it is deleted
	
	if (getAttr(Object.selectedCell,'gjsParentId')!='') {
		oParent=document.getElementById(getAttr(Object.selectedCell,'gjsParentId'));
		if (getAttr(oParent,'gjsItemType')=='CHREF') {
			Object.Item.fnRemove();
		}
		if (getAttr(oParent,'gjsItemType')!='CHREF') return;
	}
	else {
		Object.Item.fnDelete();
	}
 },

 fnOpen: function() {
	if (typeof(Object.Current)=='undefined') return;
	Object.fnOpen(getAttr(Object.selectedCell,'gjsItem'));
 },

	// Should Open menu option be offered?
 fnOpen$MenuState: function() {
  return (Class.fnSelectionCount()==1);
 },

	// Public - Transfer selected Object
 fnTransfer: function(sFunction,sLcode1,sLcode2) {
	if (typeof(Object.Current)=='undefined') return;
	
	// If we have been browsing a fileset for this location, pass it as a suffix on the location
	if ((Fileset.location==sLcode1) && (Fileset.fileset!='')) {
    sLcode1 += ':' + Fileset.fileset;
  }
	if (Class.fnSelectionCount()==1) {
		Object.fnTransfer(getAttr(Object.selectedCell,'gjsItem'),sFunction,sLcode1,sLcode2);
	}
	else {
		Object.fnTransferMultiple(sFunction,sLcode1,sLcode2);
	}
 },


	// Public - Remove Object(s) from Change Request
 fnRemove: function() {
	var sParentId,oParent
  
	if (typeof(Object.Current)=='undefined') return;
	sParentId=getAttr(Object.selectedCell,'gjsParentId')
	//
	if (sParentId=="") return;
	oParent=document.getElementById(sParentId);
	if (!oParent) return;
	if (getAttr(oParent,'gjsItemType')!='CHREF') return;
	//
	if (Class.fnSelectionCount()==1) {
		Object.fnRemove(getAttr(Object.selectedCell,'gjsItem'),getAttr(oParent,'gjsItem'),getAttr(oParent,'gjsPtext'),getAttr(Object.selectedCell,'gjsRowId'));
	}
	else {
		if (Class.fnSelectionIsContiguous()) Object.fnRemoveMultiple(getAttr(oParent,'gjsItem'),getAttr(oParent,'gjsPtext'),sParentId);
	}
 },

	// Public - Should Remove menu option be offered?
 fnRemove$MenuState: function() {
	var sParentId,oParent
	sParentId=getAttr(Object.selectedCell,'gjsParentId')
	//
	if (sParentId=="") return false;
	oParent=document.getElementById(sParentId);
	if (!oParent) return false;
	if (getAttr(oParent,'gjsItemType')!='CHREF') return false;
	return Class.fnSelectionIsContiguous();
 },

	// Public - Merge Versions
 fnMergeOpen: function() {
	if (typeof(Object.Current)=='undefined') return;
	Object.fnMergeOpen(getAttr(Object.selectedCell,'gjsLocation'),getAttr(Object.selectedCell,'gjsItem'));
 },

	// Public - Should Merge menu option be offered?
 fnMergeOpen$MenuState: function() {
  return (Class.fnSelectionCount()==1);
 },

	// Public - Cancel Version
 fnCancel: function() {
	if (typeof(Object.Current)=='undefined') return;
	Object.fnCancel(getAttr(Object.selectedCell,'gjsItem'));
 },

	// Public - Should Cancel menu option be offered?
 fnCancel$MenuState: function() {
  return (Class.fnSelectionCount()==1);
 },

	// Public - Add item to worklist
 fnWorkListCopy: function() {
	fnWorkListCopy();
 },

	// Public - Paste worklist onto selected item
 fnWorkListPaste: function() {
	fnWorkListPaste();
 },

	// Public - Should Paste menu option be offered?
 fnWorkListPaste$MenuState: function() {
  if (Class.fnSelectionCount()!=1) return false;
  return (fnWorkListCount('COMPONENT')>0);
 },

	// Public - Compare object (or pair)
 fnBCompare: function() {
	var oEl,sObv1,sLcode1,sObv2,sLcode2
	//
	if (typeof(Object.Current)=='undefined') return
	if (Class.fnSelectionCount()==1) {
		oEl=Object.selectedCell;
		sObv1=getAttr(oEl,'gjsItem');
		sLcode1=(typeof(getAttr(oEl,'gjsLocation'))=='undefined')? '' : getAttr(oEl,'gjsLocation');
		Object.fnBCompare(sObv1,sLcode1);
	}
	else if (Class.fnSelectionCount()==2) {
		oEl=fnElement(Object.selectedCells[0]);
		sObv1=getAttr(oEl,'gjsItem');
		sLcode1=(typeof(getAttr(oEl,'gjsLocation'))=='undefined')? '' : getAttr(oEl,'gjsLocation');
		oEl=fnElement(Object.selectedCells[1]);
		sObv2=getAttr(oEl,'gjsItem');
		sLcode2=(typeof(getAttr(oEl,'gjsLocation'))=='undefined')? '' : getAttr(oEl,'gjsLocation');
		Object.fnBCompare(sObv1,sLcode1,sObv2,sLcode2);
	}
 },

	// Public - Should Compare menu option be offered?
 fnBCompare$MenuState: function() {
  if (Class.fnSelectionCount()==0) return false;
  if (Class.fnSelectionCount()>2) return false;
  return true;
 }
}
