//vc/ VC/m Variable Class
//vc/ Copyright 2011 George James
//vc/ Object:    Variable.js
//vc/ Component: T.Variable.js


	// Variable Class
Variable = {}

Variable.Current=Disabled
Variable.windowProperties  = 'left=50,top=50,width=590,height=370,toolbar=no'
Variable.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no'


	// Public - Display List of menus and make this the active folder
Variable.fnList = function() {
	//
	SelectedClass=Variable
	Class.fnUnselect()
	//
	ServerLink.fnDo('Variable.fnListResult','Variable.fnList','')
}

Variable.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}


	// Public - Open new Variable window
Variable.fnNew = function() {
	fnRunWindow("Variable.fnNew",Variable.windowProperties) 
}

	// Public - Open Variable
Variable.fnOpen = function(sVariable) {
	//
	var url
	//
	// Build url string
	url  = parent.serverUrl
	url += '&page=' + escape('Variable.fnOpen')
	url += '&selectedItem=' + encodeURIComponent(sVariable)
	//
	// Open window
	winChref=window.open(url,'_blank',Variable.windowProperties)
	winChref.focus()
}

	// Public - Copy Variable
Variable.fnCopy = function(sVariable) {
	//
	var url
	//
	// Build url string
	url  = parent.serverUrl
	url += '&page=' + escape('Variable.fnCopy')
	url += '&selectedItem=' + encodeURIComponent(sVariable)
	//
	// Open window
	winChref=window.open(url,'_blank',Variable.windowProperties)
	winChref.focus()
}


	// Public - Delete an item
Variable.fnDelete = function(sVariable) {
	//
	var arguments
	//
	if (!confirm("Are you sure you want to delete this item?")) return
	//
	arguments = sVariable
  //
	parent.serverLink.fnDo('Variable.fnDeleteResult','Variable.fnDelete',arguments)
}


Variable.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result)
		return
	}
	fnRefreshSelected()
}


  // Refresh Variable
Variable.fnRefreshArguments = function(oMain)   {
  //
	var arguments=""
	//
	var arguments=""
	//
  arguments +=          getAttr(oMain,'gjsParentId')
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,'gjsRowId')+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,'gjsItem')
	arguments += '\002' + getAttr(oMain,'gjsRowId')
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,'gjsRowId')+'body').parentNode,'gjsReferenceHeadingId')
	//
	return arguments
}


  // Refresh Variable
Variable.fnRefresh = function(arguments)   {
  //
  ServerLink.fnDo('Variable.fnRefreshResult','Variable.fnRefresh',arguments)
}

Variable.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}


//---------------------
Variable.Item = {

 fnDelete: function() {
	if (typeof(Variable.Current)=='undefined') return
	Variable.fnDelete(getAttr(Variable.selectedCell,'gjsItem'))
 },

	// Public - open selected item (if there is one)
 fnOpen: function() {
	if (typeof(Variable.Current)=='undefined') return
	Variable.fnOpen(getAttr(Variable.selectedCell,'gjsItem'))
 },

	// Public - copy selected item (if there is one)
 fnCopy: function() {
	if (typeof(Variable.Current)=='undefined') return
	Variable.fnCopy(getAttr(Variable.selectedCell,'gjsItem'))
 }
}
