//vc/ Transfer Route Maintenance
//vc/ Copyright 2002 George James
//vc/ Object:    %Serenj30/1.15
//vc/ Component: T.vc300.js

	var delimiter=parent.opener.delimiter;
	var winHelpProperties = parent.opener.winHelpProperties;


	// Initialise tab strip
function fnLoad() {
	//
	// Select the first frame on the tab-strip
	TabStrip.fnSelect(document.getElementById('tabTransferRoute'));
	//
	frmMain.func.focus();
}


	//----------------------------------------------------------------------
	// Validate and save item
	//----------------------------------------------------------------------
function fnItemSaveClose() {
	parent.serverLink.fnDo('fnItemSaveCloseResult','TransferRoute.fnSave',fnArguments());
}

function fnItemSaveCloseResult(result) {
	//
	var arrResult;
	//
	arrResult=result.split(delimiter);
	if (arrResult[0]!="OK") {
		alert(result);
		return;
	}
	//
	// Update main screen (if still there)
	try {
		// If a new item (i.e. revision=1), force a full relist
		//
		Form.fnRefresh(parent.opener.TransferRoute,(arrResult[1]=="1"))
	}
	catch (error) {}
	//
	// Close the window
	parent.fnClose();
}



	//----------------------------------------------------------------------
	// Delete item
	//----------------------------------------------------------------------
function fnItemDelete() {
	var arguments;
	//
	arguments  = frmMain.func.value;
	arguments += delimiter + frmMain.from.value;
	arguments += delimiter + frmMain.to.value;
	arguments += delimiter + frmMain.revision.value;
	//
	parent.serverLink.fnDo('fnItemDeleteResult','TransferRoute.fnDelete',arguments);
}

function fnItemDeleteResult(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	//
	// Update main screen
	Form.fnRefresh(parent.opener.TransferRoute);
	//
	// Successfully deleted so close the window
	parent.fnClose();
}


function fnArguments() {
	var arguments;
	//
	arguments  = $('#func').scombobox('val');
	arguments += delimiter + frmMain.from.value;
	arguments += delimiter + frmMain.to.value;
	arguments += delimiter + frmMain.oldFunc.value;
	arguments += delimiter + frmMain.oldFrom.value;
	arguments += delimiter + frmMain.oldTo.value;
	arguments += delimiter + frmMain.revision.value;
	arguments += delimiter + frmMain.accessCodes.value;
	arguments += delimiter + frmMain.dependentLocations.value;
	arguments += delimiter + frmMain.newActiveLocations.value;
	arguments += delimiter + frmMain.masterLocation.value;
	arguments += delimiter + frmMain.category.value;
	arguments += delimiter + frmMain.transferType.value;
	arguments += delimiter + frmMain.newVersion.checked;
	arguments += delimiter + frmMain.copyOnlyIfChanged.value;
	arguments += delimiter + frmMain.statusDateHideShowPrompt.value;
	arguments += delimiter + frmMain.statusDateCaption.value;
	arguments += delimiter + $('#message').scombobox('val');
	arguments += delimiter + frmMain.comment.value;
	arguments += delimiter + frmMain.functionCaption.value;
	arguments += delimiter + frmMain.skipCategory.value;
	arguments += delimiter + frmMain.errorCategory.value;
	arguments += delimiter + frmMain.sequence.checked;
	arguments += delimiter + frmMain.disabled.checked;
	arguments += delimiter + frmMain.backupTo.value;
	arguments += delimiter + frmMain.backupFunction.value;
	return arguments;
}


function fnChangeStatDate(authOption) {
	var selOpt=authOption.value
	if (selOpt=="H")
	{
		frmMain.statusDateCaption.value="";
		frmMain.statusDateCaption.disabled=true;
	}
	if (selOpt=="P")
	{
		frmMain.statusDateCaption.value="Release date";
		frmMain.statusDateCaption.disabled=false;
	}
	if (selOpt=="S")
	{
		frmMain.statusDateCaption.value="Release date";
		frmMain.statusDateCaption.disabled=false;
	}
	g_bChanged=true;
}



	// When the user selects or changes the Transfer Type set the caption appropriately
function fnFunctionChanged() {
	//
	var oXMLDocument=$.parseXML(xFunctions.innerHTML)
	var sValue=$('#func').scombobox('val')
  
	//
	// Default the caption to resemble the function (e.g. Snap for SNAP) unless it is an AUTOF or AUTOT
	if (sValue.slice(0,5)=="AUTOF") {
		$('#functionCaption').val("")
	}
	else if (sValue.slice(0,5)=="AUTOT") {
		$('#functionCaption').val("")
	}
	else {
		$('#functionCaption').val(sValue.charAt(0).toUpperCase()+sValue.slice(1).toLowerCase())
	}
	//
	// If not a new function, preserve existing caption

	// Look up the function caption
	var cNodes=$(oXMLDocument).xpath('/functions/function[@func="'+sValue+'"]');
	if (cNodes.length==1) frmMain.functionCaption.value=cNodes[0].getAttribute('caption') 
}

function fnHelp() {
	winHelp=window.open('WebDoc/docs/managingtransferroutes.html','vcmHelp',winHelpProperties) ;
	winHelp.focus();
}
