<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:msxsl="urn:schemas-microsoft-com:xslt">


<xsl:template match="locationStatus">
  <html>
    <body>
      <table border='1'>
        <tr>
          <td>Logical</td>
          <td>Physical</td>
          <td>Access</td>
          <td>Read</td>
          <td>Read Error</td>
          <td>Write</td>
          <td>Write Error</td>
          <td>Exists</td>
          <td>Exists Error</td>
        </tr>
        <xsl:apply-templates select="logicalLocation"/>
      </table>
    </body>
  </html>
</xsl:template>

<xsl:template match="logicalLocation">
        <xsl:apply-templates select="physicalLocation"/>
</xsl:template>


<xsl:template match='physicalLocation'>
  <tr>
    <td>&nbsp;<xsl:value-of select='../@logicalLocation'/></td>
    <td>&nbsp;<xsl:value-of select='@physicalLocation'/></td>
    <td>&nbsp;<xsl:value-of select='@access'/></td>
    <td>&nbsp;<xsl:value-of select='@readAccess'/></td>
    <td>&nbsp;<xsl:value-of select='@readError'/></td>
    <td>&nbsp;<xsl:value-of select='@writeAccess'/></td>
    <td>&nbsp;<xsl:value-of select='@writeError'/></td>
    <td>&nbsp;<xsl:value-of select='@existsMethod'/></td>
    <td>&nbsp;<xsl:value-of select='@existsError'/></td>
  </tr>
</xsl:template>


</xsl:stylesheet>
