//vc/ VC/m Category Details
//vc/ Copyright 2005 George James
//vc/ Object:    Category_Details.js/1
//vc/ Component: T.Category_Details.js

	var delimiter=parent.opener.delimiter;
	var winHelpProperties = parent.opener.winHelpProperties;


	//----------------------------------------------------------------------
	// Validate and save and close
	//----------------------------------------------------------------------
function fnItemSaveClose() {
	parent.serverLink.fnDo('fnItemSaveCloseResult','Category.fnSave',fnArguments());
}

function fnItemSaveCloseResult(result) {
	//
	var arrResult;
	//
	arrResult=result.split(delimiter);
	if (arrResult[0]!="OK") {
		alert(result);
		return;
	}
	//
	// Update main screen (if still there)
	try {
		// If a new item (i.e. revision=1), force a full relist
		//
		Form.fnRefresh(parent.opener.Category,(arrResult[1]=="1"))
	}
	catch (error) {}
	//
	// Close the window
	parent.fnClose();
}



	//----------------------------------------------------------------------
	// Delete item
	//----------------------------------------------------------------------
function fnItemDelete() {
	parent.serverLink.fnDo('fnItemDeleteResult','Category.fnDelete',frmMain.category.value+delimiter+frmMain.revision.value)
}

function fnItemDeleteResult(result) {
	if (result!="OK") {
		alert(result)
		return
	}
	//
	// Update main screen
  try {
  	Form.fnSaved(parent.opener.Category)
  }
  catch (error) {}
	//
	// Successfully deleted so close the window
	parent.fnClose()
}


function fnArguments() {
  //
	var arguments,i,element,name,value
  //
  arguments=""
  for (i=0 ; i< frmMain.elements.length; i++) {
    element=frmMain.elements[i]
    if ((element.type=='text') && (element.name!="")) {
      arguments += fnNameValue(element.name,element.value)
    }
    if ((element.type=='hidden') && (element.name!="")) {
      arguments += fnNameValue(element.name,element.value)
    }
    if ((element.type=='select-one') && (element.name!="")) {
      if (element.id=="") {
        //A select-one element without an id will have originated as a gjs:select1 and been transformed into scombobox controls
        arguments += fnNameValue(element.name,$('#'+element.name).scombobox('val'))
      } else {
        arguments += fnNameValue(element.name,element.value)
      }
    }
    if (element.type=='checkbox') {
      arguments += fnNameValue(element.name,element.checked)
    }
  }
	return arguments;
}

function fnNameValue(name,value) {
  return name+'\003'+value+'\002'
}


function fnUpdateSampleColor() {
  //
  // If user selects an empty row or ---heading--- row then select default
  if ($('#color').scombobox('val')=="-") {
    document.getElementById('sampleRowNormal').style.color=''
    document.getElementById('sampleRowHighlighted').style.color=''
    return 
  }
  try {
    document.getElementById('sampleRowNormal').style.color=$('#color').scombobox('val')
    document.getElementById('sampleRowHighlighted').style.color=$('#color').scombobox('val')
    frmMain.validColorValue.value=1  // Don't know why document.getElementById('validColorValue').value doesn't work.
  }
  catch (error) { 
    //
    // If the user puts in something bad then set to default
    // Alert and set an internal error flag 
    document.getElementById('sampleRowNormal').style.color=''
    document.getElementById('sampleRowHighlighted').style.color=''
      alert("Invalid color value")
    frmMain.validColorValue.value=0  // Don't know why document.getElementById('validColorValue').value doesn't work.
  }
}


function fnUpdateSampleActionFlag() {
  if (document.getElementById('actionBy').value!="") {
    document.getElementById('sampleAction1').src='vcmFlag.gif'
    document.getElementById('sampleAction2').src='vcmFlag.gif'
  }
  else {
    document.getElementById('sampleAction1').src='vcm_blank.gif'
    document.getElementById('sampleAction2').src='vcm_blank.gif'
  }
}


function fnUpdateSampleIcon() {
  document.getElementById('sampleIcon1').src=$('#icon').scombobox('val')
  document.getElementById('sampleIcon2').src=$('#icon').scombobox('val')
}

function fnUpdateSamplePersistMessage() {
  if (document.getElementById('persistMessage').checked) {
    document.getElementById('sampleRowHighlighted').className='selectedRow'
  }
  else {
    document.getElementById('sampleRowHighlighted').className=''
  }
}

function fnHelp() {
	winHelp=window.open('WebDoc/docs/managingtheaudittrail.html#messagecategories','vcmHelp',winHelpProperties) ;
	winHelp.focus();
}
