//vc/ VC/m Printer Class
//vc/ Copyright 1999,2002 George James
//vc/ Object:    Printer.js
//vc/ Component: T.Printer.js


	// Printer Class
Printer = {}
Printer.Current=Disabled;
Printer.windowProperties  = 'left=50,top=50,width=500,height=300,toolbar=no';
Printer.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';

	// Public - Display List of printers and make this the active folder
Printer.fnList = function() {
	SelectedClass=Printer;
	Class.fnUnselect();
	//
	var html;
	html  = "<Table border='0' class='layoutTable' width='1000'>"
	html += "<tr>"
	html += "<td width='16' height='14'></td>";
	html += "<td width='25'></td>";
	//
	html += "<td width='150' class='caption' onclick='GjsTableSorter.fnSort(this,resultsTableBody,2)'>"
	html += "Printer Name"
	html += "<img class='sortIcon' src='gjsSortNormal.gif'>"
	html += "</td>"
	//
	html += "<td width='100' class='caption' onclick='GjsTableSorter.fnSort(this,resultsTableBody,3)'>"
	html += "Device Type"
	html += "<img class='sortIcon' src='gjsSortNormal.gif'>"
	html += "</td>"
	//
	html += "<td width='300' class='caption' onclick='GjsTableSorter.fnSort(this,resultsTableBody,4)'>"
	html += "Open"
	html += "<img class='sortIcon' src='gjsSortNormal.gif'>"
	html += "</td>"
	//
	html += "<td width='300' class='caption' onclick='GjsTableSorter.fnSort(this,resultsTableBody,5)'>"
	html += "Use"
	html += "<img class='sortIcon' src='gjsSortNormal.gif'>"
	html += "</td>"
	//
	html += "<td width='300' class='caption' onclick='GjsTableSorter.fnSort(this,resultsTableBody,6)'>"
	html += "Close"
	html += "<img class='sortIcon' src='gjsSortNormal.gif'>"
	html += "</td>"
	//
	html += "<td width='*'></td>";
	html += "</tr>"
	html += "</table>"
	divMainHead.innerHTML=html; 
	fnRunMain("Printer.fnList",""); 
}

	// Private - Invoked when an item is selected on the list
Printer.fnSelect = function(oCell) {
	Class.fnSelect(Printer,oCell);
}

	// Public - Open new printer window
Printer.fnNew = function() {
	fnRunWindow("Printer.fnNew",Printer.windowProperties); 
}

	// Public - Open printer
Printer.fnOpen = function(sPrinter) {
	var url;
	//
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('Printer.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sPrinter) ;
	//
	// Open printer window
	winPrinter=window.open(url,'_blank',Printer.windowProperties) ;
	winPrinter.focus();
}

	// Public - Delete a printer
Printer.fnDelete = function(sPrinter) {
	var arguments;
	//
	if (!confirm("Are you sure you want to delete "+sPrinter+" ?")) return;
	//
	arguments = sPrinter;
	//
	parent.serverLink.fnDo('Printer.fnDeleteResult','Printer.fnDelete',arguments);
}

Printer.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	Printer.fnList()
}

Printer.Item = {

 fnDelete: function() {
	if (typeof(Printer.Current)=='undefined') return;
	Printer.fnDelete(getAttr(Printer.selectedCell,'gjsItem'));
 },
 
	// Public - open selected printer (if there is one)
 fnOpen: function() {
	if (typeof(Printer.Current)=='undefined') return;
	Printer.fnOpen(getAttr(Printer.selectedCell,'gjsItem'));
 }
}

