//vc/ VC/m Selector Template
//vc/ Copyright 2005 George James
//vc/ Object:    Selector.js
//vc/ Component: T.Selector.js


function fnSelectorOutput() {
	var allObjects = "";
	for (var i = 0; i < 2; i++) {
		if (frmMain.allitems[i].checked == true) {
        allObjects = frmMain.allitems[i].value;
      }
	}
	var arguments = allObjects + delimiter;
	var selected = false;
	for (i = 0; i < frmMain.oldselectors.length; i++) {
			arguments += frmMain.oldselectors[i].value + '\002';
			selected = true;
	}
	if (selected == false) {
		arguments += "all";
	}
	return arguments;
}


function fnAddSelector(location,system) {
  var arguments;
	if (frmMain.newselector.value != "") {
		frmMain.oldselectors.selectedIndex = -1;
		frmMain.oldselectors.add(new Option(frmMain.newselector.value, frmMain.newselector.value, true, true), frmMain.oldselectors.length);
	}
	else {
		alert("Please type a selector to add");
		return;
	}
	frmMain.newselector.value = "";
  
	arguments = fnSelectorArguments(location,system);
	if (arguments != "") {
		parent.serverLink.fnDo('fnSelectorItemCountResult', 'Selector.fnChangeSelectors', arguments);
	}
	else {
		fnSelectorItemCountResult(0);
	}
	frmMain.newselector.focus();
}


function fnSelectorArguments(location,system) {
  var delimiter='\001';
  var arguments = '';
	for (var i = 0; i < frmMain.oldselectors.length; i++) {
			arguments += frmMain.oldselectors[i].value + '\002';
	}
	if (arguments != "") {
		arguments = arguments.slice(0, (arguments.length - 1));
    arguments += delimiter;
    if (typeof location == "string") {
      arguments += location;
    }
    
    arguments += delimiter;
    if (typeof system == "string") {
      arguments += system;
    } else if ((typeof system == "object") && (system != null)) {
      if (system.length > 1) {
        var syslist = '';
      	for (var i = 0; i < system.length; i++) {
      			if (system[i].checked) syslist += system[i].value + '\002';
      	}
        if (syslist.length > 0) arguments += syslist.slice(0, (syslist.length - 1));
      } else {
        if (system.checked) arguments += system.value;
      }
    }
  }
  return arguments;
}

function fnDelSelector(location,system) {
	var somethingIsSelected = false;
	var arguments;
	for (var i = 0; i < frmMain.oldselectors.length; i++) {
		if (frmMain.oldselectors[i].selected == true) {
			var somethingIsSelected = true;
			// The last deleted value will be put back in the select box
			frmMain.newselector.value = frmMain.oldselectors[i].value;
			frmMain.oldselectors[i] = null;
			i--;
		}
	}
	if (somethingIsSelected == false) {
		alert("Please choose one or more selector to remove from the list");
		return;
	}
  
  arguments = fnSelectorArguments(location,system);
	if (arguments != "") {
		parent.serverLink.fnDo('fnSelectorItemCountResult', 'Selector.fnChangeSelectors', arguments);
	}
	else {
		fnSelectorItemCountResult(0);
	}
	frmMain.newselector.select();
}


function fnSelectorItemCountResult(result) {
  var objword;
  objword = (result==1)?'object':'objects';
	itemCount.innerHTML = '<label>' + result + ' ' + objword + ' selected</label>';
}


function fnOnClick(allItems) {
	if (allItems == "1") {
		frmMain.oldselectors.disabled = true;
		frmMain.oldselectors.className = "inputDisabled";
		frmMain.oldselectors.selectedIndex = -1;
		frmMain.newselector.disabled = true;
		frmMain.newselector.className = "inputDisabled";
		frmMain.delSelector.disabled = true;
		frmMain.addSelector.disabled = true;
	}
	if (allItems == "0") {
		frmMain.oldselectors.disabled = false;
		frmMain.oldselectors.className = "input";
		frmMain.newselector.disabled = false;
		frmMain.newselector.className = "input";
		frmMain.delSelector.disabled = false;
		frmMain.addSelector.disabled = false;
		frmMain.newselector.focus();
	}
}
