//vc/ Deltanji Label management
//vc/ Copyright 2106 George James Software
//vc/ Object:    %Serenj28/1
//vc/ Component: T.vc284.js

	var delimiter=parent.opener.delimiter;
	var winHelpProperties = parent.opener.winHelpProperties;

	// Initialise tab strip
function fnLoad() {
	//
	// Select the first frame on the tab-strip
	TabStrip.fnSelect(document.getElementById('tabBasic'));
	//
	frmMain.label.focus();
}


	// Disable the form fields and put up an hourglass
function fnFormDisable(form) {
	form.className='frmWait';
  
  $(":input").not("[class|='scombobox']").each( function() {
    $(this).attr("gjsOldDisabled",$(this).prop("disabled"));
    $(this).prop("disabled",true);
  }
  )
  $(".scombobox").each( function() {
    $(this).attr("gjsOldDisabled",$(this).prop("disabled"));
    $(this).prop("disabled",true);
  }
  )
}


	// Enable the form and restore the cursor
function fnFormEnable(form) {
	form.className='frmNormal';
  
  $(":input").not("[class|='scombobox']").each( function() {
    $(this).prop("disabled", function() {
      return ($(this).attr("gjsOldDisabled")=='true');
    }
    );
  }
  )
  $(".scombobox").each( function() {
    $(this).prop("disabled", function() {
      return ($(this).attr("gjsOldDisabled")=='true');
    }
    );
  }
  )
}

	//----------------------------------------------------------------------
	// Validate and save item
	//----------------------------------------------------------------------
function fnItemSaveClose() {
  fnFormDisable(frmMain)
	parent.serverLink.fnDo('fnItemSaveCloseResult','Location.Label.fnSave',fnArguments());
}

	// When a transfer has completed we need to append the new audit message table rows to the
	// existing audit table
	//
function fnItemSaveCloseResult(oResult) {
	//
	var bErrors
	//
	// Report any errors
	bErrors=fnReportErrors(oResult)
	//
	// If there were any audit messages then write them to the message panel
	if (oResult.getElementById('divMainBody')) parent.opener.AuditTrail.fnAppendMessages(oResult)
	//
	// If there were errors re-enable controls, else close the window
	if (bErrors) {
    fnFormEnable(frmMain);
    frmMain.cmdOK.focus();
  } else {
    parent.fnClose();
  }
}

	// Report error(s) in simple alert box(es)
function fnReportErrors(oResult) {
	var oXml,oXMLDocument,cNodes,i
	oXml=oResult.getElementById('xErrors')
	if (!oXml) return false
  
  // We have to use outerHTML and the /script prefix because on Firefox innerHTML returns "" in this situation
  oXMLDocument=$.parseXML(oXml.outerHTML)
	cNodes=$(oXMLDocument).xpath('/script/errors/message')
	if (cNodes.length==0) return false
	for (i=0; i<cNodes.length; i++)	{
		// Message may contain literal \n that needs to be converted
		alert(cNodes[i].getAttribute('message').replace(/\\n/g,'\n'))
	}
        return true
}


function fnArguments() {
	var arguments;
	var i;
	var selected;
	//
	arguments  = frmMain.label.value;
	arguments += delimiter + frmMain.description.value;
	arguments += delimiter + frmMain.accessCodes.value;
	//
	arguments += delimiter;
  if (typeof(frmMain.system.length)=='undefined') {
    if (frmMain.system.checked) arguments += frmMain.system.value;
  } else {
  	for (i=0; i<frmMain.system.length; i++) {
  		if (frmMain.system[i].checked) {
  			arguments += frmMain.system[i].value;
  			arguments += '\002';
  		}
  	}
  }	
	//
	arguments += delimiter;
  if (typeof(frmMain.lclass.length)=='undefined') {
    if (frmMain.lclass.checked) arguments += frmMain.lclass.value;
  } else {
  	for (i=0; i<frmMain.lclass.length; i++) {
  		if (frmMain.lclass[i].checked) {
  			arguments += frmMain.lclass[i].value;
  			arguments += '\002';
  		}
  	}
   }	
	//
	arguments += delimiter + frmMain.sourceLocation.value;
	//
	arguments += delimiter;
  if (frmMain.allitems[1].checked) {
  	for (i=0; i<frmMain.oldselectors.length; i++) {
  		if (frmMain.oldselectors[i].value!="") {
  			arguments += frmMain.oldselectors[i].value;
  			arguments += '\002';
  		}
  	}
  }	
	//
	arguments += delimiter + frmMain.message.value;
	//
	return arguments;
}


function fnHelp() {
	winHelp=window.open('WebDoc/docs/creatinglabels.html','vcmHelp',winHelpProperties) ;
	winHelp.focus();
}
